-- Adapted from "Optimizing Your Query Plans with SQL Server 2014" 

USE [AdventureWorks2012];
GO

-- Simple containment
SELECT [od].[SalesOrderID], [od].[SalesOrderDetailID]
FROM 	[Sales].[SalesOrderDetail] AS [od]
INNER JOIN [Production].[Product] AS [p] 
ON [od].[ProductID] = [p].[ProductID]
WHERE 	[p].[Color] = 'Red' AND
[od].[ModifiedDate] = '2008-06-29 00:00:00.000'
OPTION (QUERYTRACEON 9481); -- CardinalityEstimationModelVersion 70

-- Base containment
SELECT [od].[SalesOrderID], [od].[SalesOrderDetailID]
FROM 	[Sales].[SalesOrderDetail] AS [od]
INNER JOIN [Production].[Product] AS [p] 
ON [od].[ProductID] = [p].[ProductID]
WHERE 	[p].[Color] = 'Red' AND
[od].[ModifiedDate] = '2008-06-29 00:00:00.000'
OPTION (QUERYTRACEON 2312); -- CardinalityEstimationModelVersion 120
